type 'a vector

val make : int -> 'a -> 'a vector
val init : int -> 'a -> (int -> 'a) -> 'a vector

val to_array : 'a vector -> 'a array
val of_array : 'a -> 'a array -> 'a vector

val to_list : 'a vector -> 'a list
val of_list : 'a -> 'a list -> 'a vector

(* TODO: append *)
(* TODO: concat *)
(* TODO: fill *)
(* TODO: blit *)
(* TODO: iter *)
(* TODO: map *)
(* TODO: iteri *)
(* TODO: mapi *)
(* TODO: fold_left *)
(* TODO: fold_right *)
(* array -> iterator *)
(* TODO: sort *)
(* TODO: stable_sort *)
(* TODO: fast_sort *)

val length : _ vector -> int
val default : 'a vector -> 'a

val get : 'a vector -> int -> 'a
val set : 'a vector -> int -> 'a -> unit

val resize : 'a vector -> int -> unit

val push : 'a vector -> 'a -> unit
val pop : 'a vector -> 'a

val is_empty : _ vector -> bool

val copy : 'a vector -> 'a vector

val inplace_sub : _ vector -> int -> int -> unit
val sub : 'a vector -> int -> int -> 'a vector
