
(*@ import relations *)

module type S = sig
  type t
    (*@ duplicable *)

  (*@ constant le: t -> t -> prop *)
  (*@ axiom: total_order le *)
  val compare : t -> t -> int
    (*@ r = compare x y
          ensures r <= 0 <-> le x y *)
end
